// Copyright 2020 Andy Grove
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.ballistacompute.datatypes

import org.apache.arrow.vector.types.FloatingPointPrecision
import org.apache.arrow.vector.types.pojo.ArrowType;

object ArrowTypes {
  val BooleanType = ArrowType.Bool()
  val Int8Type = ArrowType.Int(8, true)
  val Int16Type = ArrowType.Int(16, true)
  val Int32Type = ArrowType.Int(32, true)
  val Int64Type = ArrowType.Int(64, true)
  val UInt8Type = ArrowType.Int(8, false)
  val UInt16Type = ArrowType.Int(16, false)
  val UInt32Type = ArrowType.Int(32, false)
  val UInt64Type = ArrowType.Int(64, false)
  val FloatType = ArrowType.FloatingPoint(FloatingPointPrecision.SINGLE)
  val DoubleType = ArrowType.FloatingPoint(FloatingPointPrecision.DOUBLE)
  val StringType = ArrowType.Utf8()
}
